(function() {
	'use strict';
	// attach the factories and service to the [starter.services] module in
	// angular
	angular.module('starter.services').service('ReminderService',
			reminderBuilderService);
	function reminderBuilderService() {
		var self = this;
		
		self.generateReminderDate = _generateReminderDate;
		function _generateReminderDate(date,reminderCode/*codepattern: R_X_Y: X=Number , Y=W,D,H,M */) {
			try{
				var commands=reminderCode.split("_");
				var time= new Date(date.getTime());
				if("W"==commands[2]){
					var week=parseFloat(commands[1]) * 7;
					time.setDate(date.getDate()-week);
				}
				if("D"==commands[2]){
					var week=parseFloat(commands[1]);
					time.setDate(date.getDate()-week);
				}
				if("H"==commands[2]){
					var week=parseFloat(commands[1]);
					time.setDate(date.getDate());
					time.setHours(date.getHours()-week);
				}
				if("M"==commands[2]){
					var week=parseFloat(commands[1]);
					time.setDate(date.getDate());
					time.setMinutes(date.getMinutes()-week);
				}
			    return time;
			}catch(e){
				console.log("error reminderdate",e);
				return date;
			}
		}
	}
})();