angular.module('starter.controllers', [])

.controller('DashCtrl', function($scope) {})

.controller('ChatsCtrl', function($scope, Chats) {
  // With the new view caching in Ionic, Controllers are only called
  // when they are recreated or on app start, instead of every page change.
  // To listen for when this page is active (for example, to refresh data),
  // listen for the $ionicView.enter event:
  //
  //$scope.$on('$ionicView.enter', function(e) {
  //});

  $scope.chats = Chats.all();
  $scope.remove = function(chat) {
    Chats.remove(chat);
  };
})

.controller('ChatDetailCtrl', function($scope, $stateParams, Chats) {
  $scope.chat = Chats.get($stateParams.chatId);
})

.controller('AccountCtrl', function($scope) {
  $scope.language=$scope.settings.language;
  $scope.accountSettings = {
    enableAutoResiliationEmail:false
  };
})
.controller('HomeCtrl', function($filter,$scope,UserService,ContractService,AddressService,$location,$cordovaCamera,ReminderService,$cordovaLocalNotification) {
	$scope.contracts=ContractService.loadContracts($scope.actualUser.id,$scope.actualUser.token);
	$scope.addresses=AddressService.loadAddresses($scope.actualUser.id,$scope.actualUser.token);
	$scope.contractstoremind=ContractService.getContractsToRemind($scope.actualUser.id,$scope.actualUser.token);
	$scope.numberOfAddress=$scope.addresses.length;
	$scope.numberOfContract=$scope.contracts.length;
	console.log("remind in hhh",ReminderService.generateReminderDate(new Date(Date.now()),"R_30_M"));
	
	
	//For the next version
	$scope.takePicture = function() {
	        var options = { 
	            quality : 75, 
	            destinationType : Camera.DestinationType.DATA_URL, 
	            sourceType : Camera.PictureSourceType.CAMERA, 
	            allowEdit : true,
	            encodingType: Camera.EncodingType.JPEG,
	            targetWidth: 300,
	            targetHeight: 300,
	            popoverOptions: CameraPopoverOptions,
	            saveToPhotoAlbum: false
	        };
	        $cordovaCamera.getPicture(options).then(function(imageData) {
	            $scope.imgURI = "data:image/jpeg;base64," + imageData;
	        }, function(err) {
	            console.log("tes",err);
	        });
	 }
})
.controller('MainCtrl', function($scope, $ionicLoading, ReportSvc) {
    console.log('main controller');
    
});
