angular.module('starter.services', [])

.factory('Chats', function() {
  // Might use a resource here that returns a JSON array

  // Some fake testing data
  var chats = [{
    id: 0,
    name: 'Ben Sparrow',
    lastText: 'You on your way?',
    face: 'img/ben.png'
  }, {
    id: 1,
    name: 'Max Lynx',
    lastText: 'Hey, it\'s me',
    face: 'img/max.png'
  }, {
    id: 2,
    name: 'Adam Bradleyson',
    lastText: 'I should buy a boat',
    face: 'img/adam.jpg'
  }, {
    id: 3,
    name: 'Perry Governor',
    lastText: 'Look at my mukluks!',
    face: 'img/perry.png'
  }, {
    id: 4,
    name: 'Mike Harrington',
    lastText: 'This is wicked good ice cream.',
    face: 'img/mike.png'
  }];

  return {
    all: function() {
      return chats;
    },
    remove: function(chat) {
      chats.splice(chats.indexOf(chat), 1);
    },
    get: function(chatId) {
      for (var i = 0; i < chats.length; i++) {
        if (chats[i].id === parseInt(chatId)) {
          return chats[i];
        }
      }
      return null;
    }
  };
})
.factory('Ie18', function() {
	  // Might use a resource here that returns a JSON array

	  // Some fake testing data
	  var keyValue = {
			 de:{
				 "label.contract": "Vertrag",
				 "label.account": "Einstellungen",
				 "label.userprofil": "Konto",
				 'label.addresses':'Addressen',
				 'label.contracts':'Verträge',
				 'label.chat':'Chats',
				 'period':'Zeitraum',
				 'partner':'Anbieter',
				 'start':'Start',
				 'end':'Ende',
				 'typ':'Type',
				 'referenz':'Refrenz',
				 'partner.email':'Anbieter E-mail',
				 'partner.tel':'Anbieter Tel',
				 'save':'Speichern',
				 'edit':'Bearbeiten',
				 'send.email.res.template':'Kündigungsmail senden',
				 'addnewcontract':'Vertrag hinzufügen',
				 'welcome':'Willkommen',
				 'contract.remind.text':'Achtung: Rechtzeitig kündigen!!!',
				 'contact':'Kontakt',
				 'addnewaddress':'Anbieter hinzufügen',
				 'street':'Strasse',
				 'streetnumber':'Hausnummer',
				 'citycode':'PLZ',
				 'city':'Ort',
				 'country':'Land',
				 'addresses':'Addressen',
				 'delete':'Löschen',
				 'enableAutoResiliationEmail':'Kündingungstemplate automatisch',
				 'language':'Sprache',
				 'numberOfAddress':'Anzahl Addressen',
				 'numberOfContract':'Anzahl Verträge',
				 'generalInfo':'Allgemeine Infos',
				 'dateInvalid':'ungültiges Datum!',
				 'partner.street':'Anbieter Strasse',
				 'partner.country':'Anbieter Land',
				 'partner.city':'Anbieter Stadt',
				 'name':'Name',
				 'email':'E-mail',
				 'pass':'Passwort',
				 'confirmPass':'Passwort bestätigen',
				 'login':'Login',
				 'signin':'Konto erstellen',
				 'home':'Start',
				 'accountOverview':'Konto Übersicht',
				 'logout':'Abmelden',
				 'loginfail':'Anmeldung fehlgeschlagen!!!',
				 'resiliationOfContract':'Vertragskündigung',
				 'signUserExist':'Login schon vorhanden',
				  'passnomatch':'Passwort stimmen nicht überein!!!',
				  'generateLetter':'Kündingungsbrief generieren',
				  'partner.citycode':'Anbieter PLZ',
				  'companylist':'Anbieterliste',
				  'vertragtyp':'Vertragtyp',
				  'companyname':'Firmaname',
				  'telefoninternet':'Telefon/Internet',
				  'versicherung':'Versicherung',
				  'bankkredit':'Bank kredit',
				  'workcontract':'Arbeitsvertag',
				  'resiliationalarm':'Kündingungsalarm',
				  'R_15_M':'15 Min. vor Ende',
				  'R_30_M':'30 Min. vor Ende',
				  'R_1_H':'1 Stunde vor Ende',
				  'R_1_D':'1 Tag vor Ende',
				  'R_1_W':'1 Woche vor Ende',
				  'R_4_W':'1 Monat vor Ende',
				  'R_6_W':'6 Woche vor Ende',
				  'R_8_W':'2 Monate vor Ende',
				  'R_10_W':'10 Woche vor Ende',
				  'R_12_W':'3 Monate vor Ende',
				  'R_14_W':'14 Woche vor Ende',
				  'R_16_W':'4 Monate vor Ende',
				  'R_18_W':'18 Woche vor Ende',
				  'R_20_W':'5 Monate vor Ende',
				  'goback':'Zurück',
				  'feature':'Funktionalitäten',
				  'feature1':'Vertrag verwalten: anlegen, bearbeiten,löschen',
				  'feature2':'Kündingungsalarm erzeugen',
				  'feature3':'Telefon vibrieren beim Kündingungsalarm',
				  'feature4':'Benachrichtigung bekommen beim Kündigungsalarm',
				  'feature5':'Kündingungsbrief erzeugen (PDF)',
				  'feature6':'Kündingungsmail senden',
				  'feature7':'Vertraganbieter hinzufügen und löschen',
				  'feature8':'Alle Daten werden auf dem Telefon gespeichert',
				  'to':'bis',
				  'clientnumber':'Kundennummer',
				  'today':'Heute',
				  'close':'Abbrechen',
				  'set':'Übernehmen',
				  'abbr_sunday':'S', 
				  'abbr_monday':'M', 
				  'abbr_tuesday':'D', 
				  'abbr_wenesday':'M', 
				  'abbr_thursday':'D', 
				  'abbr_friday':'F', 
				  'abbr_saturday':'S',
			      'Jan':'Jan', 
			      'Feb':'Feb', 
			      'March':'März', 
			      'April':'April', 
			      'May':'Mai', 
			      'June':'Juni', 
			      'July':'Juli', 
			      'Aug':'Aug', 
			      'Sept':'Sept', 
			      'Oct':'Okt', 
			      'Nov':'Nov', 
			      'Dec':'Dez',
			      'displayname':'Anzeigetext',
			      'displaynamerequired':'Anzeigetext darf nicht leer sein',
			      'developper':'Entwickler',
			      'others':'Sonstiges',
			      'loginEmpty':'Login darf nicht leer sein'
			     
			    },
			 en:{
				 "label.contract": 'Contract',
				 "label.account": "Config",
				 "label.userprofil": "Account",
				 'label.addresses':'Addresses',
				 'label.contracts':'Contracts',
				 'label.chat':'Chats',
				 'period':'Period',
				 'partner':'Partner',
				 'start':'Start',
				 'end':'End',
				 'typ':'Typ',
				 'referenz':'Reference',
				 'partner.email':'Partner-email',
				 'partner.tel':'Partner-tel',
				 'save':'Save',
				 'edit':'Edit',
				 'send.email.res.template':'Resiliate per e-mail',
				 'addnewcontract':'Add new contract',
				 'welcome':'Welcome',
				 'contract.remind.text':'Warning: Check for resiliation!!',
				 'contact':'Contact',
				 'addnewaddress':'Add new company',
				 'street':'Street',
				 'streetnumber':'Streetnumber',
				 'citycode':'City-code',
				 'city':'City',
				 'country':'Country',
				 'addresses':'Addresses',
				 'delete':'Delete',
				 'enableAutoResiliationEmail':'Enable auto resiliation e-mail',
				 'language':'Language',
				 'numberOfAddress':'Number of Addresses',
				 'numberOfContract':'Number of contracts',
				 'generalInfo':'General infos',
				 'dateInvalid':'Not a valid date!',
				 'partner.street':'Partner street',
				 'partner.country':'Partner country',
				 'partner.city':'Partner city',
				 'name':'Name',
				 'email':'E-mail',
				 'pass':'Password',
				 'confirmPass':'Confirm password',
				 'login':'Login',
				 'signin':'create a new account',
				 'home':'Start',
				 'accountOverview':'Account overview',
				 'logout':'Logout',
				 'loginfail':'Login fail',
				 'resiliationOfContract':'Contract resiliation',
				 'signUserExist':'Login already in use',
				 'passnomatch':'Password do not match!!!',
				 'generateLetter':'Generate letter',
				 'partner.citycode':'Partner city-code',
				 'companylist':'Companylist',
				 'vertragtyp':'Contract typ',
				 'companyname':'companyname',
				 'telefoninternet':'Telefon/Internet',
				 'versicherung':'insurance',
				 'bankkredit':'Banc credit',
				 'workcontract':'Work contract',
				 'resiliationalarm':'Alarm for resiliation',
				 'R_15_M':'15 Min. before end',
				  'R_30_M':'30 Min. before end',
				  'R_1_H':'1 hour before end',
				  'R_1_D':'1 day before end',
				  'R_1_W':'1 week before end',
				  'R_4_W':'1 month before end',
				  'R_6_W':'6 weeks before end',
				  'R_8_W':'2 months before end',
				  'R_10_W':'10 weeks before end',
				  'R_12_W':'3 months before end',
				  'R_14_W':'14 weeks before end',
				  'R_16_W':'4 months before end',
				  'R_18_W':'18 weeks before end',
				  'R_20_W':'5 months before end',
				  'goback':'Go back',
				  'feature':'Feature',
				  'feature1':'Manage your contracts:create,edit,delete',
				  'feature2':'Set alarm for resiliation',
				  'feature3':'Get notifications when your contracts neering the ends.',
				  'feature4':'Resiliate your contract at time',
				  'feature5':'Generate letter of resiiation (PDF)',
				  'feature6':'sent resiliation e-amil',
				  'feature7':'Manage your Contract-company ',
				  'feature8':'All the informations are stored in your device',
				  'to':'to',
				  'clientnumber':'Identificationnumber',
				  'today':'Today',
				  'close':'close',
				  'set':'Set',
				  'abbr_sunday':'S', 
				  'abbr_monday':'M', 
				  'abbr_tuesday':'T', 
				  'abbr_wenesday':'W', 
				  'abbr_thursday':'T', 
				  'abbr_friday':'F', 
				  'abbr_saturday':'S',
			      'Jan':'Jan', 
			      'Feb':'Feb', 
			      'March':'March', 
			      'April':'April', 
			      'May':'May', 
			      'June':'June', 
			      'July':'July', 
			      'Aug':'Aug', 
			      'Sept':'Sept', 
			      'Oct':'Oct', 
			      'Nov':'Nov', 
			      'Dec':'Dec',
			      'displayname':'Displayname',
			      'displaynamerequired':'Please enter a displayname',
			      'developper':'Developper',
			      'others':'Others',
			      'loginEmpty':'Login can not be empty'
			},
			fr:{
				 "label.contract": 'Contrat',
				 "label.account": "Config",
				 "label.userprofil": "Profil",
				 'label.addresses':'Addresses',
				 'label.contracts':'Contrats',
				 'label.chat':'Chats',
				 'period':'Période',
				 'partner':'Société',
				 'start':'Acceuil',
				 'end':'Fin',
				 'typ':'Type',
				 'referenz':'Référence',
				 'partner.email':'Email de la société',
				 'partner.tel':'Tél de la société',
				 'save':'Sauvegarder',
				 'edit':'Modifier',
				 'send.email.res.template':'Résilié par e-mail',
				 'addnewcontract':'Ajouter un contrat',
				 'welcome':'Bienvenue',
				 'contract.remind.text':'Attention: Résiliation probable!!',
				 'contact':'Contact',
				 'addnewaddress':'Ajouter une société',
				 'street':'Rue',
				 'streetnumber':'Numéro rue',
				 'citycode':'Code ville ',
				 'city':'Ville',
				 'country':'Pays',
				 'addresses':'Addresses',
				 'delete':'Supprimer',
				 'enableAutoResiliationEmail':'Resiliation automatique par mail',
				 'language':'Langue',
				 'numberOfAddress':'Nombre d\'addresses',
				 'numberOfContract':'Nombre de contrats',
				 'generalInfo':'Infos générales',
				 'dateInvalid':'Date invalide!',
				 'partner.street':'Rue de la société',
				 'partner.country':'Pays de la société',
				 'partner.city':'Ville de la société',
				 'name':'Nom',
				 'email':'E-mail',
				 'pass':'Mot de pass',
				 'confirmPass':'Confirmer mot de pass',
				 'login':'Login',
				 'signin':'Créer un compte',
				 'home':'Acceuil',
				 'accountOverview':'Appercue du compte',
				 'logout':'Déconnexion',
				 'loginfail':'Login incorrect',
				 'resiliationOfContract':'Résilier le contrat',
				 'signUserExist':'Login déja utilisé',
				 'passnomatch':'Les mots de pass ne correspondent pas!!!',
				 'generateLetter':'Générer une lettre de résiliation',
				 'partner.citycode':'code-ville de la société',
				 'companylist':'Sociétés',
				 'vertragtyp':'Typ de Contrat',
				 'companyname':'Nom de la société',
				 'telefoninternet':'Telefon/Internet',
				 'versicherung':'Assurance',
				 'bankkredit':'Crédit Bancaire',
				 'workcontract':'Contrat de travail',
				 'resiliationalarm':'Alarme pour résiliation',
				 'R_15_M':'15 Min. avant la fin',
				  'R_30_M':'30 Min. avant la fin',
				  'R_1_H':'1 heure avant la fin',
				  'R_1_D':'1 jour avant la fin',
				  'R_1_W':'1 sem. avant la fin',
				  'R_4_W':'1 mois avant la fin',
				  'R_6_W':'6 sem. avant la fin',
				  'R_8_W':'2 mois avant la fin',
				  'R_10_W':'10 sem. avant la fin',
				  'R_12_W':'3 mois avant la fin',
				  'R_14_W':'14 sem. avant la fin',
				  'R_16_W':'4 mois avant la fin',
				  'R_18_W':'18 sem. avant la fin',
				  'R_20_W':'5 mois avant la fin',
				  'goback':'Retour',
				  'feature':'Fonctionnalités',
				  'feature1':'Gérer ses contrats:créer,modifier,supprimer',
				  'feature2':'Définir une alarme pour les résiliations',
				  'feature3':'Recevoir des messages lorsqu\'un contract tire à sa fin',
				  'feature4':'Résilier les contrats dans les délais',
				  'feature5':'Générer les lettres de résiliations',
				  'feature6':'Envoyer des E-mails de résiliations',
				  'feature7':'Gérer vos fournisseurs de contrats',
				  'feature8':'Toutes les données sont enregistrés sur votre portable',
				  'to':'jusqu\'a',
				  'clientnumber':'Numéros d\'identification',
				  'today':'Aujourd\'hui',
				  'close':'fermer',
				  'set':'sélectionner',
				  'abbr_sunday':'D', 
				  'abbr_monday':'L', 
				  'abbr_tuesday':'M', 
				  'abbr_wenesday':'M', 
				  'abbr_thursday':'J', 
				  'abbr_friday':'V', 
				  'abbr_saturday':'S',
			      'Jan':'Jan', 
			      'Feb':'Fev', 
			      'March':'Mars', 
			      'April':'Avril', 
			      'May':'Mai', 
			      'June':'Juin', 
			      'July':'Juillet', 
			      'Aug':'Aout', 
			      'Sept':'Sept', 
			      'Oct':'Oct', 
			      'Nov':'Nov', 
			      'Dec':'Déc',
			      'displayname':'Texte d\'identification',
			      'displaynamerequired':'Entrer un texte pour identifier le contrat',
			      'developper':'Développeur',
			      'others':'Autres',
			      'loginEmpty':'Entrer un login'
			}

	    
			    
	  };

	  return {
	    all: function() {
	      return keyValue;
	    },
	    get: function(lan,key) {
	    	if(keyValue[lan]==null){
	    		return null;
	    	}
	      return keyValue[lan][key];
	    }
	  };
	})
	
	.factory('EmailService', function() {
    _sendMessage= function(message,subject,to) {
    	console.log("message", message);
    	tos=[];
    	tos.push(to);
        if(window.plugins && window.plugins.emailComposer) {
            window.plugins.emailComposer.showEmailComposerWithCallback(function(result) {
                console.log("Response -> " + result);
            }, 
            subject, // Subject
            message,                      // Body
            tos,    // To
            null,                    // CC
            null,                    // BCC
            true,                   // isHTML
            null,                    // Attachments
            null);                   // Attachment Data
        }
    };
    return {
    	sendMessage:function(message,subject,to){
    		_sendMessage(message,subject,to);
    	}
    }
})
.factory('viewerService', 
['$document', '$window', function ($document, $window) {
	var _type = "";
	var _open;
	$document[0].addEventListener("deviceready", function () {
		_open = $window.open;
		if (device.platform === "iOS") {
			_type = "_blank";
		}
		else if (device.platform === "Android") {
			_type = "_system";
		}
		else {
			_type = "_system";
		}

	}, false);
	return {
		showPDF: function (fileToShow) {
			_open(encodeURI(fileToShow),_type,'location=no')
		}
	}
}])
.factory('PdfMaker',function($filter,ReportSvc,viewerService){
	

	_createResiliationPDF=function(daten){

        //if no cordova, then running in browser and need to use dataURL and iframe
        if (!window.cordova) {
            ReportSvc.runReportDataURL( {},{},daten )
                .then(function(dataURL) {
                    //set the iframe source to the dataURL created
                    console.log('report run in browser using dataURL and iframe');
                    document.getElementById('pdfImage').src = dataURL;
                });
            return true;
        }
        //if codrova, then running in device/emulator and able to save file and open w/ InAppBrowser
        else {
            ReportSvc.runReportAsync( {},{},daten )
                .then(function(filePath) {
                	viewerService.showPDF(filePath);
                    //log the file location for debugging and oopen with inappbrowser
                    console.log('report run on device using File plugin');
                    console.log('ReportCtrl: Opening PDF File (' + filePath + ')');
                });
            return true;
        }
	
	};
	return {
		createResiliationPDF:function(user,contract,lang){
			daten={
					'user':user,
					'contract':contract,
					'lang':lang,
					'resiliateDate':$filter('date')(contract.end, "dd.MM.yyyy"),
					'placeDate':user.city+", "+ $filter('date')(new Date(), "dd.MM.yyyy")
					
			};
    		_createResiliationPDF(daten);
    	}
    }
})
.factory('FileReader',function($filter,$http){
	_readFile=function(file,contract,user,subject,sendMessage){
		$http.get(file, function(res) {
//	        console.log("index.html", res);
	    }).success(function(res){
	    	var allText = res;
	    	var partnercitycode=contract.partnerCityCode?contract.partnerCityCode+" ":"";
            allText=allText.replace("__ort_date__",user.city+", "+ $filter('date')(new Date(), "dd.MM.yyyy"));
            allText=allText.replace("__organisation_name__",contract.partner);
            allText=allText.replace("__organisation_strasse__",contract.partnerStreet);
            allText=allText.replace("__contract_reference__",contract.referenz);
            allText=allText.replace("__organisation_city__",partnercitycode+ contract.partnerCity);
            allText=allText.replace("__organisation_country__",contract.partnerCountry);
            allText=allText.replace("__resiliate_time__",$filter('date')(contract.end, "dd.MM.yyyy"));
            allText=allText.replace("__contract_owner__",user.fullname);
            allText=allText.replace("__contract_number__",contract.clientnumber);
            sendMessage( allText,subject,contract.partnerEmail);
	    }).error(function(e){
	    	console.log("file not found",e);
	    });
		
	};
	return {
    	readFile:function(file,contract,user,subject,callback){
    		_readFile(file,contract,user,subject,callback);
    	}
    }
})
;
