angular.module('starter.usermanagement.controllers', [])
.controller('AuthCtrl', function($rootScope,$scope,UserService,ContractService,$location) {
	$scope.loginfail=false;
	$rootScope.actualUser={
			  login:'',
			  pass:'',
			  fullname:'',
			  city:'',
			  token:'',
			  email:'',
			  street:'',
			  citycode:'',
			  city:'',
			  country:''
			  
	  };
	  $scope.authenticate=function(login,pass){
		  if(UserService.authenticate(login,pass)){
				$scope.loginfail=false;
				$rootScope.actualUser=UserService.actualUser;
				$location.path('/tab/home');
				
			}else{
				$scope.loginfail=true;
				$location.path('/login');
			}
	  };
	  $scope.gotoSignin=function(){
		  $location.path('/signin');
	  }
	  
	
})
.controller('UserProfilCtrl', function($filter,$rootScope,$scope,UserService,ContractService,AddressService,$location,$cordovaCamera,$ionicHistory,$timeout,$state) {
	$scope.actualUser=UserService.actualUser;	
	$scope.sign={
			  login:UserService.actualUser.login,
			  fullname:UserService.actualUser.fullname,
			  city:UserService.actualUser.city,
			  email:UserService.actualUser.email,
			  street:UserService.actualUser.street,
			  citycode:UserService.actualUser.citycode,
			  city:UserService.actualUser.city,
			  country:UserService.actualUser.country
	};
	$scope.edit=function(){
		  this.editing=!this.editing;
	  };
	  $scope.editing=false;
	  $scope.save=function(){
		  var user=UserService.get($scope.actualUser.id);
		  if(user!=null){
			  user.fullname=$scope.sign.fullname;
			  user.city=$scope.sign.city;
			  user.email=$scope.sign.email;
			  user.street=$scope.sign.street,
			  user.citycode=$scope.sign.citycode,
			  user.city=$scope.sign.city,
			  user.country=$scope.sign.country
			  UserService.update(user.id,user);
		  }
		  this.editing=false;
	  }
	  $scope.logout=function(){
		  
			  UserService.actualUser={};
			  $rootScope.actualUser={
					  login:'',
					  pass:'',
					  fullname:'',
					  city:'',
					  token:'',
					  email:'',
					  street:'',
					  citycode:'',
					  city:'',
					  country:''
			  };
			  //$ionicHistory.clearCahe();
			  $ionicHistory.clearHistory();
			  
			  $ionicHistory.nextViewOptions({
		            disableBack: true,
		            historyRoot:true
		        });
			  $location.path('/login');
		  
		 
	  }
})
.controller('SignCtrl', function($scope,UserService,$location) {
	$scope.sign={
			  login:'',
			  fullname:'',
			  city:'',
			  pass1:'',
			  pass2:'',
			  email:'',
			  street:'',
			  citycode:'',
			  city:'',
			  country:''
	  };
	  $scope.signin=function(){
		  //TODO : call webservice to register
		  var entry=this.sign;
		  this.signUserExist=false;
		  this.passnomatch=false;
		  if(entry.pass1!=entry.pass2){
			  this.passnomatch=true;
			  return;
		  }
		  user ={
					login : entry.login,
					name:'',
					surname:'',
					pass:entry.pass1,
					token : '',
					fullname:entry.fullname,
					city:entry.city,
					email:entry.email,
					street:entry.street,
					citycode:entry.citycode,
					city:entry.city,
					country:entry.country,
					id:0
				};
		  if(user.login==''|| user.login.trim()==''){
			 this.loginEmpty=true;
			 document.getElementById("logininput");
			 console.log(document);
			 return;
		  }
		  if(UserService.userExist(user)){
			  this.signUserExist=true;
			  return;
		  }
		  UserService.register(user);
		  $location.path('/login');
		  
	  };
	
})

;
