angular.module('starter.usermanagement.services', []).factory('UserService',
		function($localStorage,$rootScope) {
			// Might use a resource here that returns a JSON array

			// Some fake testing data
			return {
				actualUser : {
						login : '',
						name:'',
						surname:'',
						pass:'',
						token : '',
						fullname:'',
						city:'',
						id:0
					},
				authenticate : function(login, pass) {
					this.actualUser={};
					for(i=0;i<$localStorage.users.length;i++){
						var _user=$localStorage.users[i];
						if(_user.login==login && _user.pass==pass ){
							this.actualUser=_user;
							return true;
						}
					}
					if (login == "test" && pass == "test") {
						this.actualUser.login = login;
						this.actualUser.token = 'token';
						this.actualUser.pass=pass;
						this.actualUser.city='Muster city';
						this.actualUser.fullname='Max Musterman';
						this.actualUser.id=0;
						return true;
					}
					return false;
				},
				isTokenOK : function() {
					if (this.actualUser == null) {
						return false;
					}
					return this.actualUser.token == "token";
				},
				get:function(userid){
					for(i=0;i<$localStorage.users.length;i++){
						var _user=$localStorage.users[i];
						if(_user.id==userid){
							return _user;
						}
					}
					
					return null;
				},
				userExist:function(user){
					for(i=0;i<$localStorage.users.length;i++){
						var _user=$localStorage.users[i];
						if(_user.login==user.login){
							return true;
						}
					}
					
					return false;
				},
				register:function(user){
					user.id=$rootScope.nextid();
					$localStorage.users.push(user);
					return true;
				},
				remove:function(id){
					var usertemp=this.get(id);
					$localStorage.users.splice($localStorage.users.indexOf(usertemp), 1);
					
				},
				update:function(id,user){
					this.remove(id);
					$localStorage.users.push(user);
				}
			};
		});
