angular.module('starter.addressmanagement.controllers', [])
.controller('AddCtrl', function($scope,AddressService,$location,UserService) {
	$scope.actualUser=UserService.actualUser;
	$scope.addressdto={
			  city:'',
			  citycode:'',
			  street:'',
			  streetnumber:'',
			  country:'',
			  token:'',
			  companyname:'',
			  companytyp:'',
			  email:'',
			  uid:UserService.actualUser.id
	  };
	  $scope.addAddress=function(){
		  AddressService.addAddress($scope.addressdto);
		  $location.path("/tab/addressoverview");
				
			
	  };
	  $scope.addresses=AddressService.loadAddresses($scope.actualUser.id,$scope.actualUser.token);
	
})
.controller('AddrDetailCtrl', function($timeout,$scope, $stateParams, $location, AddressService,ContractService,UserService) {
  $scope.userId=$stateParams.userId;
  $scope.address = AddressService.get($stateParams.addrId);
  $scope.companyContracts=ContractService.loadForCompany($stateParams.addrId,$scope.userId);
  window.addrDetailCtrlScope = $scope;
  $scope.updateCompanyContract=function(){
	  $scope.companyContracts = ContractService.loadForCompany($scope.address.id,$scope.userId);
	  
  };
  $scope.edit=function(){
	  this.editing=!this.editing;
  };
  $scope.editing=false;
 
  $scope.save=function(){
	  AddressService.update($scope.address.id,$scope.address);
	  this.editing=false;
  }
  $scope.remove=function(){
	  AddressService.remove($stateParams.addrId);
	  $location.path("/tab/addressoverview");
  }
})
;
